#ifndef CONFIG_H
#define CONFIG_H 1

#include "constants.h"
// expression profile distance measure
// 1 Spearman rank correlation
// 2 Mutual information
#define DISTANCE_MEASURE   SPEARMANK_RANK_CORRELATION_DISTANCE // MUTUAL_INFORMATION_DISTANCE // PEARSON_CORRELATION_DISTANCE // 
#define DISTANCE_DATA USE_RATIO_DATA

// 
//#define PATHWAY_CONNECTIVITY 1

// minimal length of the linear pathway (number of doubly-linked nodes)
#define MINIMAL_LINEAR_PATHWAY_LENGTH 3

// change calculation to include only gene pairs from long linear pathways
// (i.e. the vast majority of the genes will be ignored in such calculations)
#define CALCULATE_LINEAR_PATHWAY_PAIRS_ONLY 1

// discount experiments in which neither gene has been significantly perturbed
#define OMIT_UNPERTURBED_EXPERIMENTS 1

// the fraction of experiments that have to be valid
// in order for the distance to be recorded
#define MIN_VALID_EXPERIMENT_FRACTION 0.75

// upper limit of the mimimum P value for a pair of experiments
#define MIN_PVALUE_PERTURBATION 0.1

// p value threshold used for mutual information
// p value discretization
// PVALUE_CUTOFF is defined in mcstats.h

// A flag identifying if distances on the metabolic map 
// should be computed using directed paths
//#define USE_DIRECTED_PATHS 1

#endif
