#ifndef MCIO_H
#define MCIO_H 1

#include "mctypes.h"
#include <iostream>
#include <vector>
#include <fstream>
#include <sstream>
#include <strstream>
#include <string>
#include <boost/tokenizer.hpp>

using namespace std;

void read_gene_set(vector<string>& gene_names, string& gene_set_fname);
void read_connectivity(vector<ipType>& connectivity, string& connectivity_fname);
bool read_expression(vector<string>& experiment_names,GeneExpressionMapType& expression_data,GeneSetType& gene_names_set,string& expression_fname,GeneExpressionMapType* previous_expression_data,bool check,bool keep_all_data);

// std:: extensions
namespace std {
  template<typename charT, typename traits, typename T1, typename T2> inline std::basic_istream<charT,traits>& std::operator>> (std::basic_istream<charT,traits>& is, std::pair<T1,T2>& p);
  template<typename _T1,typename _T2>   ostream& operator<<(ostream& out, const pair<_T1,_T2> p ) {
    out<<'('<<p.first<<','<<p.second<<')';
    return out;
  }

  template<typename basicT>  ostream& operator<<(ostream& out,const vector<basicT> v);
};


#endif
