#ifndef MCSTATS_H
#define MCSTATS_H 1

#include "mctypes.h"
#include <vector>

// p value threshold used for mutual information
// p value discretization
#define PVALUE_CUTOFF 0.1

/*
extern "C" {
  void spear(float data1[], float data2[], unsigned long n, float *d, float *zd,float *probd, float *rs, float *probrs);
  void pearsn(float x[], float y[], unsigned long n, float *r, float *prob,float *z);
}
*/

inline int discrete_value(double pv,double iv);
pair<double,double> calculate_PValue_spearman_distance(const vector<double>& pv1,const vector<double>& iv1,const vector<double>& pv2,const vector<double>& iv2,vector<int>* valid_experiments);
pair<double,double> calculate_PValue_pearson_distance(const vector<double>& pv1,const vector<double>& iv1,const vector<double>& pv2,const vector<double>& iv2,vector<int>* valid_experiments);
pair<double,double> calculate_ratio_pearson_distance(const vector<double>& rv1,const vector<double>& rv2,vector<int>* valid_experiments);
pair<double,double> calculate_PValue_mi_distance(const vector<double>& pv1,const vector<double>& iv1,const vector<double>& pv2,const vector<double>& iv2,vector<int>* valid_experiments);
pair<double,double> calculate_ratio_spearman_distance(const vector<double>& rv1,const vector<double>& rv2,vector<int>* valid_experiments);

#endif
