#ifndef MCTYPES_H
#define MCTYPES_H 1

#include "config.h"
#include <hash_map.h>
#include <hash_set.h>
#include <boost/graph/adjacency_list.hpp>

using namespace std;


typedef pair<int,int> ipType;
typedef hash_map<string, vector<double>, hash<string>, equal_to<string> > GeneExpressionMapType;
typedef set<string> GeneSetType;

#ifdef USE_DIRECTED_PATHS
typedef boost::adjacency_list< boost::vecS, boost::vecS, boost::directedS, boost::no_property, boost::property<boost::edge_weight_t,int> > GraphType;
#else
typedef boost::adjacency_list< boost::vecS, boost::vecS, boost::undirectedS, boost::no_property, boost::property<boost::edge_weight_t,int> > GraphType;
#endif

#define HASH_NAMESPACE __gnu_cxx

namespace HASH_NAMESPACE {
  template<> struct HASH_NAMESPACE::hash< pair<int,int> > {
    size_t operator()(const pair<int,int>& __x) const { return __x.first*__x.second; }
  };

  template <> struct HASH_NAMESPACE::hash<string> {
    size_t operator()(const string& s) const {
      hash<const char*> hash_function;
      return hash_function(s.c_str());
    }
  };
};

struct eqpair {
  bool operator()(const pair<int,int>& p1,const pair<int,int>& p2) const {
    return (p1.first==p2.first && p1.second==p2.second);
  }
};

typedef hash_set<pair<int,int>, hash< pair<int,int> >, eqpair > GenePairSetType;


#endif
