#ifndef NPCONNECTIVITY_H
#define NPCONNECTIVITY_H 1
#include "nptypes.h"
typedef hash_map<string, int, hash<string>, equal_to<string> > GeneIdMapType;

class NPConnectivity {
protected:
  GraphType& g;
  vector<string>& names;
  GeneIdMapType gene_ids;
  
public:
  NPConnectivity(GraphType& graph,vector<string>& gene_names): g(graph),names(gene_names) {};
  virtual vector< vector<string> > get_neighbours(string gene,int radius) {};
};

class NPClosestConnectivity : public NPConnectivity {
private:
  vector< vector<int> >  connectivity_distance;
public:
  NPClosestConnectivity(GraphType& graph,vector<string>& gene_names);
  vector< vector<string> > get_neighbours(string gene,int radius); 
};

#endif
