#ifndef SIMAN_H
#define SIMAN_H 1
#include <vector>
#include <string>
#include <gsl/gsl_siman.h>

#include "npconnectivity.h"
#include "npdist.h"

using namespace std;

// simulated annealing control structure
typedef struct siman_control_struct {
  vector<string> *ptr_metabolic_genes;
  vector<string> *ptr_nme_genes;
  NPDist  *ptr_npd;
  NPConnectivity  *ptr_npc;
  vector<double> *ratios;
} Siman_control_struct_type;

// simulated annealing functions
double siman_f(void *xp);
double siman_metric(void *xp, void *yp);
void siman_step(const gsl_rng * r, void *xp, double step_size);
void siman_print(void *xp);
void* siman_copy_construct(void *source);
void siman_copy(void *source,void *dest);
void siman_destroy(void *source);
#endif
